void initusart(void)//initializing function
{
 unsigned char x;            // Hilfsvariable
 #ifdef UBRRL                 // USART-Schnittstelle 
  UBRRL = (TAKT / (8 * BAUD)) - 1;
  UCSRA |= (1 << U2X);
  UCSRB |= (1 << TXEN) | (1 << RXEN);
  UCSRC |= (1 << URSEL) | (1 << UCSZ1) | (1 << UCSZ0); 
 #else                    // UART-Schnittstelle
  UBRR = (TAKT / (16 * BAUD)) - 1;
  UCR |= (1 << TXEN) | (1 << RXEN);
 #endif 
 x = UDR;                // Empfnger leeren
}


void putch (unsigned char x)  // warten und Zeichen senden
{
 #ifdef UCSRA
  loop_until_bit_is_set(UCSRA, UDRE); // warte bis Sender frei
 #else
  loop_until_bit_is_set(USR, UDRE);   // warte bis Sender frei
 #endif
 UDR = x;                             // Zeichen nach Sender    
}


unsigned char getch(void)   // warten und Zeichen abholen
{
 #ifdef UCSRA
 loop_until_bit_is_set(UCSRA, RXC);    // warte bis Zeichen da
#else 
 loop_until_bit_is_set(USR, RXC);      // warte bis Zeichen da
 #endif
 return UDR;                           // Zeichen abholen
}


// getche.c warten, Zeichen abholen und im Echo senden
unsigned char getche(void)
{
 unsigned char x;
 loop_until_bit_is_set(UCSRA, RXC);
 x = UDR;
 loop_until_bit_is_set(UCSRA, TXC);
 UDR = x;
 return x;
}


// c:\cprog\kbit.c kein Zeichen: Rckgabe 0 sonst Rckgabe Zeichen
unsigned char kbhit(void)         // Empfnger testen
{
 #ifdef UCSRA                       // USART
 if (UCSRA & (1 << RXC)) return UDR; else return 0;
#else                               // UART
 if ( USR & (1 << RXC)) return UDR; else return 0;   
 #endif
}


// c:\cprog3\putstring.c  String bis Endemarke Null ausgeben
void putstring(unsigned char *zeiger)  // SRAM_String ausgeben
{
 while(*zeiger != 0) putch(*zeiger++); // solange keine Endemarke NULL
}


// c:\cprog\getstring.c  String max. SLAENG mit Korrekturen lesen 
unsigned char getstring(unsigned char *zeiger) 
{
 unsigned anz = 0;                       // Zeichenzhler
 while(1)
 {
  *zeiger = getch();                     // Zeichen lesen ohne Echo
  if(*zeiger >= 0x20 && anz < SLAENG)    // kein Steuerzeichen
  {
   putch(*zeiger); anz++; zeiger++;     // Echo Zhler Zeiger erhhen
  } // Ende if
  else 
  {
   if(*zeiger != '\b' || anz >= SLAENG)  // Ende der Eingaben
   {
    anz = *zeiger; *zeiger = 0; return anz;      
   } // Ende if
   else 
   if(*zeiger == '\b' && anz != 0)     // Korrektur mit Rcktaste 
   {
    zeiger--; putch('\b'); putch(' '); putch('\b'); anz--;
   }  // Ende if
  } // Ende else 
 } // Ende while
}  // Ende Funktion



// c:\cprog3\cmpstring.c Stringvergleich  1:gleich  0:ungleich
unsigned char cmpstring(unsigned char *s1, unsigned char *s2)
{
 while(1)
 {
  if( (*s1 == 0) && (*s2 == 0) ) return 1; //   ja:  gleich
  if(*s1 != *s2) return 0;                  // nein: ungleich
  s1++; s2++;                                // weiter
 } // Ende  while 
} // Ende cmpstring
