/////MYOS V1.0
//header declaration
//--------constant declaration, task structure and function declaration
#include<stdbool.h>
#include<string.h>
#include<util/delay.h>
//stack pointer adress
#define SPH   0X3E
#define SPL   0x3D

//maxim number of tasks
#define NR_MAX_TASK 4
//boolean values
#define T_EROARE    0//error - false
#define T_OK        1//ok - true

//tick time period - multiple of timer interrupts (e.g. for interrupt 1ms tick time is 63ms)
#define TICK_TIME   63 //

//task stack size (software and hardware stack)
#define OSTaskStkSize 100    //total stack size
#define OSTaskStkSizeHard 24 //hardware stack size
#include<avr/io.h>
#include<avr/interrupt.h>
#include "port_declare.c"
//task type definition
typedef struct t{
  unsigned char adr_task[OSTaskStkSize];//task stack
//
  unsigned char nr_timpi;//task time - number of tick time periods
  unsigned char activ;//task status
} task;

//myos function declaration
void start_so(void);//init real time kernel
unsigned char creaza_task(void (*taskf)(void),unsigned char numar);//create a task
unsigned char comuta_task(void);//task switch
void get_tsp(void);//init tsp and tr variables - used for compatibilitiy with assembler
void push_var(void);//push in task stack global variables
void pop_var(void);//pop from task stack global variable
void init_task(void);//init first task context- used to start multitasking
void  PopSP(void);//init the stack pointer with first task function - used to start multitasking
//void control_on(void);
//void control_off(void);

//myos optional functions - used if work with semaphores
void lcd_req(void);//request access to LCD
void lcd_release(void);//release LCD resource
void comuta(void);//switch current task - called when hardware resource is busy - semaphore busy

//another functions
void delay_1_ms(unsigned int time);//delay


//USART
void usart_init(void);
//maximum size of sending parametres (2...256)
#define STX_SIZE	20
#define	SRX_SIZE	100

#define BIT_TIME	(u16)(XTAL * 1.0 / BAUD + 0.5)

#define	TX_HIGH		(1<<COM1A1^1<<COM1A0)
#define	TX_LOW		(TX_HIGH^1<<COM1A0)
#define	TX_OUT		TCCR1A		// use compare output mode

#define ROLLOVER( x, max )	x = ++x >= max ? 0 : x
					// count up and wrap around


