#include"global.c"
#include"my_os.c"

#include <stdbool.h>
#include<avr/io.h>


register bool akku asm("r3");
register char realakku asm("r2");
register int intakku asm("r4");
unsigned int ref;

//Structures for functions

typedef struct{
bool CLK;  //Eingangsparameter
bool Q;  //Ausgangsparameter
	      }R_TRIG,F_TRIG;

 typedef struct{
	bool IN;//Eingangsparameter
	int PT;
int ET;//Ausgangsparameter
bool Q;
	  }TP;

typedef struct{
	bool IN,Q;
	int ET,PT;
	     }TON;

 typedef struct {
		bool IN,Q;
		int ET,PT;
		}TOF;

  typedef struct {
		bool CU,RESET,Q;
		int PV,CV;
	          }CTU;

 typedef struct {
		bool CD,LOAD,Q;
		int CV,PV;
	       }CTD;

  typedef struct {
		bool CU,CD,LOAD,RESET,QU,QD;
		int CV,PV;
	          }CTUD;             

ISR(SIG_OVERFLOW1)
{
//disable interrupt
  cli();

//save registers using Y pointer
  asm("ST      -Y,R27");
  asm("ST      -Y,R26");
  asm("ST      -Y,R25");
  asm("ST      -Y,R24");
  asm("ST      -Y,R31");
  asm("ST      -Y,R30");
  asm("ST      -Y,R3");
  asm("ST      -Y,R2");
  asm("ST      -Y,R1");
  asm("ST      -Y,R0");
  asm("ST      -Y,R23");
  asm("ST      -Y,R22");
  asm("ST      -Y,R21");
  asm("ST      -Y,R20");
  asm("ST      -Y,R19");
  asm("ST      -Y,R18");
  asm("ST      -Y,R17");
  asm("ST      -Y,R16");
  asm("IN      R26,0x3F");
  asm("IN      R27,0x3B");
  asm("  ST -Y, R4");
  asm("  ST -Y, R5");
  asm("  ST -Y, R6");
  asm("  ST -Y, R7");
  asm("  ST -Y, R8");
  asm("  ST -Y, R9");
  asm("  ST -Y, R10");
  asm("  ST -Y, R11");
  asm("  ST -Y, R12");
  asm("  ST -Y, R13");
  asm("  ST -Y, R14");
  asm("  ST -Y, R15");
  asm("  ST -Y, R26");

  global_inc++;//increment interrupt counter variable for time expire task switching
  global_inc_g++;//increment time counter for delay function


//test time expire
  if(b_start_so)//only if start OS
   {
   if(global_inc>=(task_time*TICK_TIME))//if time period for current task expire
   {
//init interrupt counter variable
    global_inc=0;
//init t_sp and t_r variables
    t_sph=0;
    t_spl=0;
    t_r29=0;
    t_r28=0;
    get_tsp();//

//save Y pointer for current task
    asm("  LDS R30,t_r28");//R26 <- t_r28
    asm("  LDS R31,t_r29");//R27 <- t_r29
    asm("  ST -Z, R28");//salvare pointer Y
    asm("  ST -Z, R29");

//save stack pointer for current task
    asm("  LDS R30,t_spl");//stack pointer is saved using Y pointer already saved
    asm("  LDS R31,t_sph");
    asm("  IN R16,0x3d");//save SPH
    asm("  ST -Z,R16");
    asm("  IN R16,0x3e");//save SPL
    asm("  ST -Z,R16");


    push_var();//save global variables
    comuta_task();//task switching
    pop_var();//restore global variables for new current task

//restore stack pointer for new current task
  asm("  LDS R28,t_spl");
  asm("  LDS R29,t_sph");
  asm("  LD R16,-Y");
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//restore Y pointer for new current task
  asm("  LDS R30,t_r28");
  asm("  LDS R31,t_r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

   }

  }

 //restore all registers
  asm("  LD R26,Y+");
  asm("  LD R15,Y+");
  asm("  LD R14,Y+");
  asm("  LD R13,Y+");
  asm("  LD R12,Y+");
  asm("  LD R11,Y+");
  asm("  LD R10,Y+");
  asm("  LD R9,Y+");
  asm("  LD R8,Y+");
  asm("  LD R7,Y+");
  asm("  LD R6,Y+");
  asm("  LD R5,Y+");
  asm("  LD R4,Y+");

  asm("OUT     0x3B,R27");
  asm("OUT     0x3F,R26");
  asm("LD      R16,Y+");
  asm("LD      R17,Y+");
  asm("LD      R18,Y+");
  asm("LD      R19,Y+");
  asm("LD      R20,Y+");
  asm("LD      R21,Y+");
  asm("LD      R22,Y+");
  asm("LD      R23,Y+");
  asm("LD      R0,Y+");
  asm("LD      R1,Y+");
  asm("LD      R2,Y+");
  asm("LD      R3,Y+");
  asm("LD      R30,Y+");
  asm("LD      R31,Y+");
  asm("LD      R24,Y+");
  asm("LD      R25,Y+");
  asm("LD      R26,Y+");
  asm("LD      R27,Y+");

//enable interrupt
  sei();
//when return restart function for current task
}
ISR(SIG_USART_RECV)//oder USART_RXC_vect
{
cli();
//	if((UDR&((1<<7)|(1<<6))&&(UDR|((1<<0)|(1<<1)|(1<<2))))  //Commandbyte:11 _ _ _ 111
//{
//	if(UDR&((0<<3)|(0<<4)|(0<<5)))
//	{
//		Command_byte=0;
//	}
//	else if(UDR&((1<<3)|(0<<4)|(0<<5)))
//	{
//		Command_byte=1;
//		USART_frame_init();
//	}
//	else if(UDR&((0<<3)|(1<<4)|(0<<5)))
//	{
//		Command_byte=2;
//		USART_frame_init();
//	}
//	else if(UDR&((1<<3)|(1<<4)|(0<<5)))
//	{
//		Command_byte=3;
//		USART_frame_init();
//	}
//	else if(UDR&((0<<3)|(0<<4)|(1<<5)))
//	{
//		Command_byte=4;
//	}
//	else Command_byte=5;
//}
//else{
//switch(Command_byte)
//{
//	case 0:{//Offline
//		break;}
//	case 1:{//Reset

//		break;}
//	case 2:{//normaler Betrieb
//		break;}
//	case 3:{//changing value
//		break;}
//	case 4:{//Offline mode
//		break;}
//	default :{break;}
//}
//}


//}
//sei();
//}
//ISR(SIG_USART_DATA) {
//cli();
//UCSRB &= ~(1<<UDRIE);

//sei();

//}

//IS
//gloFreq=UDR*5;
//tasks functions description
void delay(int t)
{
  do{
  }
  while(i<t); 
  i=0;
}       




//functions

void R_TRIG_f(R_TRIG r_trig)
{
	bool m;
	akku=r_trig.CLK;
	akku&=~m;	
	r_trig.Q=akku;
	m=r_trig.CLK;
}
  
            
void F_TRIG_f(F_TRIG f_trig)
{	
	bool m;
	akku=~f_trig.CLK;
	akku&=~m;
	f_trig.Q=akku;
	m=~f_trig.CLK;
}
               
                
void TP_f(TP tp){
	
	bool tp_alt,stfl;
	//steigende Flankenerkennung
	akku=tp.IN;
	akku&=~tp_alt;	
	stfl=akku;
	tp_alt=tp.IN;
	
	if(stfl)	      {
			ref=global_inc;
			tp.Q=true;
		      }
	else if(tp.Q){
			tp.ET=global_inc-ref;
	if(tp.ET>tp.PT)	{
			tp.Q=false;
			tp.ET=0;
			}
               	     	}
	          }

void TON_f(TON ton){

	bool tp_alt,m,tp_Q,stfl,ffl;

	//steigende Flankenerkennung fr Timerstart
	akku=ton.IN;
	akku&=~tp_alt;	
	stfl=akku;
	tp_alt=ton.IN;
	
	if(stfl)	      {
			ref=global_inc;
			tp_Q=true;
		      }
	else if(tp_Q){
			ton.ET=global_inc-ref;
	if(ton.ET>ton.PT)	{
			tp_Q=false;
			ton.ET=0;
			}
               	     	}
	
//bei fallender Flanke von Timer und Timer_input true->Output true 
	akku=~ton.IN;
	akku&=~m;
	ffl=akku;
	m=~ton.IN;
	if(ffl&&ton.IN) ton.Q=true;
	}
                
void TOF_f(TOF tof){
	bool tp_alt,ffl;
	//fallende Flankenerkennung
	akku=~tof.IN;
	akku&=tp_alt;
	ffl=akku;
	tp_alt=tof.IN;
	
	if(ffl)	      {
			ref=global_inc;
			tof.Q=true;
		      }
	else if(tof.Q)	{
				tof.ET=global_inc-ref;
	if(tof.ET>tof.PT)		{
				tof.Q=false;
				tof.ET=0;
				}
               	     		}
	         	      }

	}

             
void ctu_f(CTU ctu){
	if(ctu.RESET){
	ctu.CV=0;
	ctu.Q=false;
		     }
	bool m; bool sfl;
//steigende Flankenerkennung
	akku=ctu.CU;
	akku&=~m;	
	sfl=akku;
	m=ctu.CU;
	if(sfl) ctu.CV++;
	if(ctu.CV>ctu.PV)ctu.Q=true;
	}

              
void ctd_f(CTD ctd){
bool m,sfl;
	if(ctd.LOAD){
			ctd.CV=ctd.PV;
			ctd.Q=false;
	}
	
//steigende Flankenerkennung
	akku=ctd.CD;
	akku&=~m;	
	sfl=akku;
	m=ctd.CD;
	if(sfl) ctd.CV--;
	if(ctd.CV==0)ctd.Q=true;
	}                
        

        
void ctud_f(CTUD ctud){
bool sfl_up,sfl_down,m;
	if(ctud.LOAD){
		ctud.CV=ctud.PV;
		ctud.QD=false;
		ctud.QU=false;
		     }
else if(ctud.RESET){ctud.CV=0;
		    ctud.QU=false;
		   }
//steigende Flankenerkennung frs dekrementieren
	akku=ctud.CD;
	akku&=~m;	
	sfl_down=akku;
	m=ctud.CD;
//steigende Flankenerkennung frs inkrementieren
	akku=ctud.CU;
	akku&=~m;	
	sfl_up=akku;
	m=ctud.CU;

if(sfl_down) ctud.CV--;
if(sfl_up) ctud.CV++;
if(ctud.CV==0)ctud.QD=true;
if(ctud.CV==ctud.PV)ctud.QU=true;
		      }
               
